/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef ARTSMEDIA_H
#define ARTSMEDIA_H

#include "common.h"

// includes of other idl definitions
#include "artsflow.h"

namespace Arts {
class Format : public Arts::Type {
public:
	Format();
	Format(bool dummy);
	Format(Arts::Buffer& stream);
	Format(const Format& copyType);
	Format& operator=(const Format& assignType);
	bool dummy;

// marshalling functions
	void readType(Arts::Buffer& stream);
	void writeType(Arts::Buffer& stream) const;
};

};
namespace Arts {
class MediaModule;

class MediaModule_base : virtual public Arts::SynthModule_base {
public:
	static unsigned long _IID; // interface ID

	static MediaModule_base *_create(const std::string& subClass = "Arts::MediaModule");
	static MediaModule_base *_fromString(std::string objectref);
	static MediaModule_base *_fromReference(Arts::ObjectReference ref, bool needcopy);

	inline MediaModule_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual std::vector<std::string> _defaultPortsIn() const;
	virtual std::vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual bool isSupported(const Arts::Format& fmt, const std::string& strm) = 0;
	virtual Arts::Format proposeFormat(const Arts::Format& proposal, const std::string& strm) = 0;
	virtual bool setFormat(const Arts::Format& fmt, const std::string& strm) = 0;
	virtual Arts::Format getFormat(const std::string& strm) = 0;
};

class MediaModule_stub : virtual public MediaModule_base, virtual public Arts::SynthModule_stub {
protected:
	MediaModule_stub();

public:
	MediaModule_stub(Arts::Connection *connection, long objectID);

	bool isSupported(const Arts::Format& fmt, const std::string& strm);
	Arts::Format proposeFormat(const Arts::Format& proposal, const std::string& strm);
	bool setFormat(const Arts::Format& fmt, const std::string& strm);
	Arts::Format getFormat(const std::string& strm);
};

class MediaModule_skel : virtual public MediaModule_base, virtual public Arts::SynthModule_skel {
public:
	MediaModule_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	bool _isCompatibleWith(const std::string& interfacename);
	void _buildMethodTable();
	void dispatch(Arts::Buffer *request, Arts::Buffer *result,long methodID);
};

};
#include "reference.h"
namespace Arts {
class MediaModule : public Arts::Object {
private:
	static Arts::Object_base* _Creator();
	MediaModule_base *_cache;
	inline MediaModule_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(MediaModule_base *)_pool->base->_cast(MediaModule_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

protected:
	inline MediaModule(MediaModule_base* b) : Object(b), _cache(0) {}


public:
	typedef MediaModule_base _base_class;

	inline MediaModule() : Arts::Object(_Creator), _cache(0) {}
	inline MediaModule(const Arts::SubClass& s) :
		Arts::Object(MediaModule_base::_create(s.string())), _cache(0) {}
	inline MediaModule(const Arts::Reference &r) :
		Arts::Object(r.isString()?(MediaModule_base::_fromString(r.string())):(MediaModule_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline MediaModule(const Arts::DynamicCast& c) : Arts::Object(MediaModule_base::_fromString(c.object().toString())), _cache(0) {}
	inline MediaModule(const MediaModule& target) : Arts::Object(target._pool), _cache(target._cache) {}
	inline MediaModule(Arts::Object::Pool& p) : Arts::Object(p), _cache(0) {}
	inline static MediaModule null() {return MediaModule((MediaModule_base*)0);}
	inline static MediaModule _from_base(MediaModule_base* b) {return MediaModule(b);}
	inline MediaModule& operator=(const MediaModule& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator Arts::SynthModule() const { return Arts::SynthModule(*_pool); }
	inline MediaModule_base* _base() {return _cache?_cache:_method_call();}

	inline Arts::AutoSuspendState autoSuspend();
	inline void start();
	inline void stop();
	inline void streamInit();
	inline void streamStart();
	inline void streamEnd();
	inline bool isSupported(const Arts::Format& fmt, const std::string& strm);
	inline Arts::Format proposeFormat(const Arts::Format& proposal, const std::string& strm);
	inline bool setFormat(const Arts::Format& fmt, const std::string& strm);
	inline Arts::Format getFormat(const std::string& strm);
};

// Forward wrapper calls to _base classes:

inline Arts::AutoSuspendState Arts::MediaModule::autoSuspend()
{
	return _cache?static_cast<Arts::SynthModule_base*>(_cache)->autoSuspend():static_cast<Arts::SynthModule_base*>(_method_call())->autoSuspend();
}

inline void Arts::MediaModule::start()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->start():static_cast<Arts::SynthModule_base*>(_method_call())->start();
}

inline void Arts::MediaModule::stop()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->stop():static_cast<Arts::SynthModule_base*>(_method_call())->stop();
}

inline void Arts::MediaModule::streamInit()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamInit():static_cast<Arts::SynthModule_base*>(_method_call())->streamInit();
}

inline void Arts::MediaModule::streamStart()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamStart():static_cast<Arts::SynthModule_base*>(_method_call())->streamStart();
}

inline void Arts::MediaModule::streamEnd()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamEnd():static_cast<Arts::SynthModule_base*>(_method_call())->streamEnd();
}

inline bool Arts::MediaModule::isSupported(const Arts::Format& fmt, const std::string& strm)
{
	return _cache?static_cast<Arts::MediaModule_base*>(_cache)->isSupported(fmt, strm):static_cast<Arts::MediaModule_base*>(_method_call())->isSupported(fmt, strm);
}

inline Arts::Format Arts::MediaModule::proposeFormat(const Arts::Format& proposal, const std::string& strm)
{
	return _cache?static_cast<Arts::MediaModule_base*>(_cache)->proposeFormat(proposal, strm):static_cast<Arts::MediaModule_base*>(_method_call())->proposeFormat(proposal, strm);
}

inline bool Arts::MediaModule::setFormat(const Arts::Format& fmt, const std::string& strm)
{
	return _cache?static_cast<Arts::MediaModule_base*>(_cache)->setFormat(fmt, strm):static_cast<Arts::MediaModule_base*>(_method_call())->setFormat(fmt, strm);
}

inline Arts::Format Arts::MediaModule::getFormat(const std::string& strm)
{
	return _cache?static_cast<Arts::MediaModule_base*>(_cache)->getFormat(strm):static_cast<Arts::MediaModule_base*>(_method_call())->getFormat(strm);
}

};
#endif /* ARTSMEDIA_H */
